--[[ PotionMaker by MrInfernal  v1.0

    Can search by potion name or effect, then select a number to make
    Will purchase the required number of ingredients and then craft

    ToDo:
    Check Tradeskill Depot
    Create events to track: if out of money, if out of ingredients
    Get more money if needed from bank
    Get the ingredients to make more potions until complete
    Check for and equip trophy. Re-equip weapon afterwards
]]

local mq = require('mq')
---@type ImGui
local imgui = require 'ImGui'

-- set variables
Potions = require('potions')
local numPot = '1' -- How many potions to make
local typeAndEffects = {{type='Buff', effects={'Damage Shield', 'Everlasting Breath', 'Group Everlasting Breath', 'Group Shrink', 
'Group Spirit of the Wolf', 'Grow', 'Group Levitation', 'Haste', 'Levitation', 'Shrink', 'Spirit of the Wolf'}},
{type='Buffs: Divination', effects={'Faerune', 'Improve Archery', 'Improved Invisibility', 'Infravision', 'Invisibility', 'Invis vs Undead', 'See Invisible', 
'Ultravision'}},
{type='Direct Damage When Casting', effects={'Any Spells', 'Chromatic Spells', 'Cold Spells', 'Disease Spells', 'Fire Spells', 'Magic Spells', 'Poison Spells'}},
{type='Heal/Regen', effects={'Cure Disease', 'Cure Poison', 'Heal', 'Heal over Time', 'HP and Mana Regen', 'HpToMana', 'ManaToHP', 'Mana Regen', 'Regeneration'}},
{type='Increase', effects={'Beneficial Duration', 'Detrimental Duration', 'Spell Distance'}},
{type='Illusion: B-G', effects={'Barbarian', 'Dark Elf', 'Drakkin', 'Dwarf', 'Erudite', 'Gnome', 'Guktan'}},
{type='Illusion: H-V', effects={'Halfling', 'Half Elf', 'High Elf', 'Human', 'Iksar', 'Ogre', 'Troll', 'Wood Elf', 'Vah Shir'}},
{type='Illusion: Enemy', effects={'Basilisk', 'Bear', 'Earth Elemental', 'Fairy', 'Goblin', 'Imp', 'Kobold', 'Skeleton'}},
{type='Reduce Mana', effects={'Beneficial Spells', 'Chromatic Spells', 'Cold Spells', 'Disease Spells', 'Fire Spells', 'Magic Spells', 'Poison Spells'}},
{type='Resist', effects={'Resist Cold', 'Resist Disease', 'Resist Fire', 'Resist Magic', 'Resist Poison'}},
{type='Spell', effects={'Cancel Magic', 'Gate', 'Gate: Everfrost', 'Gate: Field of Bone', 'Gate: Innothule', "Gate: Shadeweaver's Thicket", 
'Gate: Twilight Sea', 'Nullify Magic', 'Shadow Step'}},
{type='Stat', effects={'Increase Agility', 'Increase Charisma', 'Increase Dexterity', 'Increase HP and AC', 'Increase Intelligence', 
'Increase Mana', 'Increase Stamina', 'Increase Strength', 'Increase Wisdom'}}
    }
local levelSelect = 1
local potLevel = {'Any', 'I', 'II', 'III', 'IV', 'V', 'VI', 'VII', 'VIII', 'IX', 'X', 'XI', 'XII', 'XIII',
                'XIV', 'XV', 'XVI', 'XVII', 'XVIII', 'XIX', 'XX', 'XI', 'XII'}
local selectedTypeIndex = 1
local selectedEffectIndex = 1
local selectedPotionIndex = 1
local typeSelect = ''
local effectSelect = ''
local lookupResults = {}
local selectedPotion = {}
AlcSkill = mq.TLO.Me.Skill("Alchemy")()
MyCash = mq.TLO.Me.Cash()/1000
local useCWTN = false
local useForage = false
local gatedToPOK = false
local onlyVendor = false
local buyPot = false
local makePot = false
PotMade = 0

-- Functions
local function updateSkill()
    AlcSkill = mq.TLO.Me.Skill('Alchemy')()
end

local function updateCash()
    MyCash = mq.TLO.Me.Cash()/1000
end

local function goToVendor(zone)
    -- Check if bound in PoK and then gates. Otherwise, runs to PoK
    if zone ~= 'poknowledge' then
        if mq.TLO.Me.ZoneBound() == 'The Plane of Knowledge' then
            if mq.TLO.Me.AltAbilityReady('Gate') then
                mq.cmd('/squelch /casting "gate" alt')
                print('Gating to Plane of Knowledge')
                gatedToPOK = true
            else
                if useCWTN then
                    mq.cmd('/squelch /shm pause on')
                end
                mq.cmd('/squelch /casting "gate"')
                print('Gating to Plane of Knowledge')
                gatedToPOK = true
            end
        else
        mq.cmd('/travelto poknowledge @locyxz -332.10 824.41 -92.87')
        print('Traveling to Alchemist Redsa in the Plane of Knowledge!')
        end
    else
        mq.cmd('/easyfind nav locyxz -332.10 824.41 -92.87')
    end
end

local function checkCWTN()
    if mq.TLO.Plugin('mq2shaman').IsLoaded() and mq.TLO.Me.Class.Name() == 'Shaman' then
        useCWTN = true
    else
        useCWTN = false
    end
end

local function checkForage()
    if mq.TLO.Plugin('mq2autoforage').IsLoaded() then
        useForage = true
    else
        useForage = false
    end
end

local function gatedToPOKEvent()
    -- After gating, this turns the MQ2Shaman back on if it was paused
    -- Also continues travel to the alchemy merchant
    if gatedToPOK then
        gatedToPOK = false
        if useCWTN and mq.TLO.CWTN.Paused() then
            mq.cmd('/squelch /shm pause off')
        end
        mq.cmd('/easyfind nav locyxz -332.10 824.41 -92.87')
    end
end

local function potLookup(type, effect, level, onlyVendor)
    local results = {}

    for _, pot in ipairs(Potions) do
        if level > 1 then
            if onlyVendor then
                if pot.type == type and pot.effect == effect and pot.level == tonumber(level)-1 and pot.vendor then
                    table.insert(results, pot)
                end
            else
                if pot.type == type and pot.effect == effect and pot.level == tonumber(level)-1 then
                table.insert(results, pot)
                end
            end
        else
            if onlyVendor then
                if pot.type == type and pot.effect == effect and pot.vendor then
                    table.insert(results, pot)
                end
            else
                if pot.type == type and pot.effect == effect then
                table.insert(results, pot)
                end
            end  
        end
    end

    return results
end

local function matList(potion)
    local matsCount = {}
    local matLength = 0

    if potion then
        -- Check for potion ingredients as well as quantity
        for _, mat in ipairs(potion.mats) do
            if matsCount[mat] then
                matsCount[mat] = matsCount[mat] + 1
                matLength = matLength + 1
            else
                matsCount[mat] = 1
                matLength = matLength + 1
            end
        end
    else
        print('No potion selected!')
    end

    return matsCount, matLength
end

--- Buying functions
local function tarRedsa()
    if not mq.TLO.Window('MerchantWnd').Open() and mq.TLO.Spawn('redsa').Distance() < 20 then
        mq.cmd('/multiline ; /tar redsa; /timed 5 /click right target')
    end
end

local function matCount(potion, numPots)
    local matsCount, matLength = matList(potion)

    -- How many potions to make
    local multiplier = tonumber(numPots) 

    -- Multiply counts if needed
    for mat, count in pairs(matsCount) do
        matsCount[mat] = count * multiplier
    end
    return matsCount, matLength
end

local function buyMats(potion, pots)
    local matsCount, matLength = matCount(potion, pots)
    local buyPot = true
    local numMats = 0
    local matHave = 0

    -- Don't buy items we don't need
    for mat, count in pairs(matsCount) do
        local ownedMat = mq.TLO.FindItemCount(mat)()
        numMats = numMats + 1
        if ownedMat > 0 then
            if matsCount[mat] - ownedMat < 0 then
                matsCount[mat] = 0
                matHave = matHave + 1
            else
                matsCount[mat] = matsCount[mat] - ownedMat
            end
        end            
    end
 
    if matHave < numMats then
        tarRedsa()
        while not mq.TLO.Window('MerchantWnd').Open() do
            mq.delay(500)
        end
        while not mq.TLO.Merchant.ItemsReceived() do
            mq.delay(500)
        end
        -- Select and buy
        for mat, count in pairs(matsCount) do
            if count > 0 then
                mq.TLO.Merchant.SelectItem('=' .. mat)
                mq.delay(500)
                if mq.TLO.Merchant.SelectedItem() == mat then
                    mq.TLO.Merchant.Buy(count)
                    mq.delay(500)
                end
            end
        end
        if mq.TLO.Window('MerchantWnd').Open() then
            mq.TLO.Window('MerchantWnd').DoClose()
        end
        return buyPot
    else
        print('Do not need to purchase any ingredients')
    end
end

--- Creating functions
local function needPaused()
    -- Pause MQ2AutoForage and MQ2Shaman
    if useForage then
        mq.cmd('/squelch /stopforage')
    end

    if useCWTN then
        mq.cmd('/squelch /shm pause on')
    end
end

local function getBag()
    -- Find medicine bag, store the name and bagslot, open the bag
    local packSlots = {
        {slot=23, name='pack1'}, {slot=24, name='pack2'}, {slot=25, name='pack3'}, {slot=26, name='pack4'}, 
        {slot=27, name='pack5'}, {slot=28, name='pack6'}, {slot=29, name='pack7'}, {slot=30, name='pack8'}
    }
    local bagSlot = ''
    local bagData

    if mq.TLO.Window('MerchantWnd').Open() then
        mq.TLO.Window('MerchantWnd').DoClose()
    end

    --Check for and open medicine bag in inventory
    for packIndex = 23, 32 do
        local packs = mq.TLO.Me.Inventory(packIndex)

        -- Check if the item is a medicine bag
        if packs and packs.Type() == 'Medicine' then
            for _, packInfo in ipairs(packSlots) do
                if packInfo.slot == packIndex then
                    bagSlot = packInfo.name
                    bagData = packs
                    break
                end
            end
        end
    end
    return bagSlot, bagData
end

--[[local function doAuto(potion, numToMake)
    local toMake = tonumber(numToMake)

    for i=1, toMake do
        while not mq.TLO.Window('TradeskillWnd/COMBW_CombineButton').Enabled() do
            mq.delay(500)
        end
        mq.TLO.Window('TradeskillWnd/COMBW_CombineButton').LeftMouseUp()
        printf('Combine %d/%d', i, toMake)

        mq.delay(250)
        mq.cmd('/autoinv')
    end

    if PotMade == toMake then
        printf('\agSuccess: \axMade all %d %s', toMake, potion.name)
    elseif toMake > PotMade and PotMade > 0 then
        printf('\ayPartial Success: \axMade %d of %d %s', PotMade, toMake, potion.name)
    elseif PotMade == 0 then
        printf('\arFailure: \axAll %d %s failed', toMake, potion.name)
    end

    if mq.TLO.Window('TradeskillWnd').Open() then
        mq.TLO.Window('TradeskillWnd').DoClose()
    end
end]]

local function doManual(potion, pots, bagSlot, bagData)
    local toMake = tonumber(pots)

    if bagData.Open() ~= 1 then
        mq.cmdf('/itemnotify "%s" rightmouseup', bagData.Name())
    end

    if mq.TLO.Window('TradeskillWnd').Open then
        mq.TLO.Window('TradeskillWnd/COMBW_ExperimentButton').LeftMouseUp()
    end
    mq.delay(500)
    
    for j = 1, toMake do
        for i = 1, #potion.mats do
            local matName = potion.mats[i]
        
            -- Check if the string starts with an asterisk
            if string.sub(matName, 1, 1) == '*' then
                -- Remove the asterisk
                matName = string.sub(matName, 2)
            end

            mq.cmdf('/nomodkey /ctrl /itemnotify "%s" leftmouseup', matName)
            mq.delay(400)   
            mq.cmdf('/itemnotify in %s %d leftmouseup', bagSlot, i)
            mq.delay(400)
            if i == #potion.mats then
                mq.cmdf('/combine %s', bagSlot)
                mq.delay(400)
                mq.cmdf('/autoinv')
                mq.delay(400)
                printf('Combine: %d/%d', j, numPot)
                mq.delay(400)
            end
        end
    end

    if PotMade == toMake then
        printf('\agSuccess: \axMade all %d %s', toMake, potion.name)
    elseif toMake > PotMade and PotMade > 0 then
        printf('\ayPartial Success: \axMade %d of %d %s', PotMade, toMake, potion.name)
    elseif PotMade == 0 then
        printf('\arFailure: \axAll %d %s failed', toMake, potion.name)
    end

    if bagData.Open > 0 then
        bagData.DoClose()
    end
end

--[[local function checkRecipe(potion, pots, bagSlot, bagData)
    if bagData.Open() ~= 1 then
        mq.cmdf('/itemnotify "%s" rightmouseup', bagData.Name())
    end

    while not mq.TLO.Window('TradeskillWnd').Open() do
        mq.delay(500)
    end

    local rList = mq.TLO.Window('TradeskillWnd/COMBW_RecipeList')

    if rList.List('='..potion.name)() ~= rList.GetCurSel() then
        mq.TLO.Window('TradeskillWnd/COMBW_SearchTextEdit').SetText(potion.name)
        
        while not mq.TLO.Window('TradeskillWnd/COMBW_SearchButton').Enabled() do
            mq.delay(500)
        end

        mq.TLO.Window('TradeskillWnd/COMBW_SearchButton').LeftMouseUp()
    end

    while not mq.TLO.Window('TradeskillWnd/COMBW_RecipeList').Enabled() do
        mq.delay(500)
    end

    if mq.TLO.Window('TradeskillWnd/COMBW_RecipeList').Enabled() then
        mq.delay(500)
        local listItem = mq.TLO.Window('TradeskillWnd/COMBW_RecipeList').List('='..potion.name)()
        mq.TLO.Window('TradeskillWnd/COMBW_RecipeList').Select(listItem)
    end

    if rList.List('='..potion.name)() == rList.GetCurSel() then
        doAuto(potion, pots)
    else
        doManual(potion, pots, bagSlot, bagData)
    end
end]]

local function eventMadePotion()
    PotMade = PotMade + 1
end

local function needUnpaused()
    -- Pause MQ2AutoForage and MQ2Shaman
    if useForage then
        mq.cmd('/squelch /startforage')
    end

    if useCWTN then
        mq.cmd('/squelch /shm pause off')
    end
    local makePot = false
    return makePot
end

-- function to run the window
local function potionMaker(open)
    -- Specify a default position/size
    local main_viewport = imgui.GetMainViewport()
    imgui.SetNextWindowPos(main_viewport.WorkPos.x + 600, main_viewport.WorkPos.y + 20, ImGuiCond.FirstUseEver)

    -- change the window size
    imgui.SetNextWindowSize(600, 300, ImGuiCond.FirstUseEver)

    local show = false
    open, show = imgui.Begin("Potion Maker", open)

    if not show then
        mq.unevent('gated')
        mq.unevent('skilled')
        mq.unevent('cash')
        mq.unevent('madepotion')

        ImGui.End()
        return open
    end

    ImGui.PushItemWidth(ImGui.GetFontSize() * -12);

    -- Main window element area --
    imgui.Text("Alchemy Skill:")
    imgui.SameLine()
    imgui.Text(AlcSkill)

    imgui.SameLine(175)
    imgui.Text('Plat: ')
    imgui.SameLine()
    imgui.Text(tostring(MyCash))

    imgui.SameLine(550)
    if ImGui.Button("Go to vendor") then
        local doVendor = coroutine.create(function()
            goToVendor(mq.TLO.Zone.ShortName())
        end)
        coroutine.resume(doVendor)
    end
    imgui.SameLine()
    if ImGui.Button('Stop') then
        mq.cmd('/squelch /nav stop')
    end

    ImGui.Separator()
    -- Potion selection
    imgui.Columns(4)  -- Set up columns

    -- Display types in the first column
    imgui.Text("          Type")
    imgui.Text('\n')
    for i, pot in ipairs(typeAndEffects) do
        local isSelectedType = (i == selectedTypeIndex)
    
        -- Display the type as a selectable label
        if imgui.Selectable(pot.type, isSelectedType) then
            -- Handle selection logic for types here
            selectedTypeIndex = i
            typeSelect = pot.type
        end
    end
    
    imgui.NextColumn()
    
    -- Display effects in the second column for the selected type
    imgui.Text("         Effects")
    imgui.Text('\n')
    if selectedTypeIndex <= #typeAndEffects then
        local selectedEffects = typeAndEffects[selectedTypeIndex].effects
        for i, effect in ipairs(selectedEffects) do
            local isSelectedEffect = (i == selectedEffectIndex)
    
            -- Display the effect as a selectable label
            if imgui.Selectable(effect, isSelectedEffect) then
                -- Handle selection logic for effects here
                selectedEffectIndex = i
                effectSelect = effect
            end
        end
    end

    imgui.NextColumn()

    imgui.Text('            Level')
    imgui.Text('\n')

    levelSelect = imgui.Combo(" ", levelSelect, potLevel, #potLevel)

    imgui.NextColumn()

    imgui.Text('\n\n')

    if imgui.Button('Lookup') then
        lookupResults = potLookup(typeSelect, effectSelect, levelSelect, onlyVendor)
    end
    imgui.SameLine()
    if imgui.Button('Reset') then
        selectedTypeIndex = 1
        selectedEffectIndex = 1
        levelSelect = 1
        lookupResults = {}
    end

    onlyVendor = imgui.Checkbox("Only Store bought", onlyVendor)

    imgui.Text('\n')
    imgui.Text('Quantity:    ')
    imgui.SameLine()
    numPot = imgui.InputText('', tostring(numPot))

    if imgui.Button('Buy Mats') then
        if selectedPotion and tonumber(numPot) > 0 then
            DoBuy = coroutine.create(function(potion, pots)
                buyMats(potion, pots)
            end)
            buyPot = true
        else
            print('No potion selected!')
        end
    end
    imgui.SameLine()
    if imgui.Button('Make Potion') then
        if selectedPotion then
            PotMade = 0
            DoMake = coroutine.create(function()
                needPaused()
                local bagSlot, bagData = getBag()
                --checkRecipe(selectedPotion, numPot, bagSlot, bagData)
                doManual(selectedPotion, numPot, bagSlot, bagData)
                needUnpaused()
            end)
            makePot = true
        else
            print('No potion selected!')
        end
    end
    --[[imgui.Text(' ')
    imgui.SameLine(80)
    local showPause = false
    if not showPause then
        if imgui.Button('Pause Potion') then
            makePot = false
            showPause = true
        end
    elseif showPause then
        if imgui.Button('Resume Potion') then
            makePot = true
            showPause = false
        end
    end]]

    imgui.Text('\n')

    imgui.Columns(1)  -- Reset columns

    ImGui.Separator()
    -- Only display results if any are available
    if lookupResults and #lookupResults > 0 then
        -- Potions found
        imgui.Text('Potions')
        imgui.Text('\n')
        imgui.Text('Name')
        imgui.SameLine(225)
        imgui.Text('Trivial')
        imgui.SameLine(300)
        imgui.Text('Yields')
        imgui.SameLine(350)
        imgui.Text('Materials')
        imgui.SameLine(425)
        imgui.Text('Storebought Materials')

        -- Display information about selected potions
        for i, potion in ipairs(lookupResults) do
            local label = potion.name
            local isSelected2 = selectedPotionIndex == i
            if imgui.Selectable(label, isSelected2) then
                selectedPotion = potion
                selectedPotionIndex = i
            end

            local materials, matLength = matList(potion)
            local materialInfo = ""
            for mat, count in pairs(materials) do
                materialInfo = materialInfo .. mat .. ": " .. count .. "\n"
            end

            imgui.SameLine(225)
            imgui.Text('   ' .. potion.trivial)

            imgui.SameLine(300)
            imgui.Text('     ' .. potion.yield)

            imgui.SameLine(370)
            imgui.HelpMarker(materialInfo)

            imgui.SameLine(425)
            local vendor = potion.vendor and 'Yes' or 'No'
            imgui.Text('               ' .. vendor)
        end
    end
    -- End of main window element area --

    -- Required for window elements
    imgui.Spacing()
    imgui.PopItemWidth()
    imgui.End()
    return open
end

checkCWTN()
checkForage()

mq.event('gated', 'You have entered The Plane of Knowledge#*#', gatedToPOKEvent)
mq.event('skilled', '#*#better at Alchemy! #*#', updateSkill)
mq.event('money', '#*#You have purchased #1# from Alchemist Redsa for#*#', updateCash)
mq.event('madepotion', '#*#You have fashioned#*#', eventMadePotion)

local openGUI = true

ImGui.Register('potionMaker', function()
    openGUI = potionMaker(openGUI)
end)

while openGUI do
    mq.doevents()
    mq.delay(300)
    if buyPot then
        coroutine.resume(DoBuy, selectedPotion, numPot)
    end
    if makePot then
        coroutine.resume(DoMake, selectedPotion, numPot)
    end
end